package Auto::Nakladni;
# definuje třídu Auto::Nakladni jako potomka třídy Auto
# přidává metody:
#    naloz(kolik)    přidá náklad; vrátí, zda se vešlo
#    vyloz()         vyprázdní náklad
# mění metody:
#    stav()          zobrazení aktuálního stavu

use Moose;
extends "Auto";

has nosnost => ( is => 'ro', isa => 'Num' );
has naklad => ( is => 'rw', isa => 'Num', default => 0 );

sub naloz {
    my $self = shift;
    my $kolik = shift;
    if ( $kolik + $self->naklad > $self->nosnost ) {
        print "Překročena nosnost! Naloženo ",
            $self->nosnost - $self->naklad, " t.\n";
        $self->naklad( $self->nosnost );
    } else {
        $self->naklad( $self->naklad + $kolik );
    }
    return $self->{"naklad"};
}

sub vyloz {
    my $self = shift;
    my $vylozeno = $self->naklad;
    $self->naklad( 0 );
    return $vylozeno;
}

sub stav {
    my $self = shift;
    $self->SUPER::stav();
    print "Náklad: ", $self->naklad, "\n";
}

1;
