package Trida::Rozhrani;

use Exporter 'import';
our @EXPORT = qw(dej_znak pridej_zaka smaz_zaka najdi_zaka
             seznam_abecedne seznam_prospech);

use locale;
use Log;

sub dej_znak {
    print "Zadejte příkaz\n";
    print "  n ... přidat žáka\n";
    print "  d ... vymazat žáka\n";
    print "  j ... seznam žáků abecedně\n";
    print "  p ... seznam žáků podle prospěchu\n";
    print "  r ... načíst z disku\n";
    print "  s ... uložit na disk\n";
    print "  q ... konec\n";
    print "> ";
    my $vstup = <STDIN>;
    return substr( $vstup, 0, 1 );
}

sub pridej_zaka {
    print "Příjmení a jméno: ";
    my $jmeno = <STDIN>; chomp( $jmeno );
    print "Průměr:           ";
    my $prumer = <STDIN>; chomp( $prumer );
    push( @_, "$jmeno:$prumer" );
    do_logu( "Přidán žák $jmeno.\n" );
    return @_;
}

sub najdi_zaka {
    my @zaci = @_;
    print "Příjmení a jméno: ";
    my $jmeno = <STDIN>; chomp( $jmeno );
    for ( my $i=0; $i<@zaci; $i++ ) {
        if ( $zaci[$i] =~ /^$jmeno:/ ) {
            return $i;
        }
    }
    return -1;
}

sub smaz_zaka {
    my $index = najdi_zaka(@_);
    if ( $index > -1 ) {
        my ( $jmeno ) = $zaci[$index] =~ /^(.*):/;
        splice( @_, $index, 1 );
        print "Žák $jmeno vymazán.\n";
        do_logu( "Vymazán žák $jmeno.\n" );
    } else {
        print "Žák nenalezen.\n";
    }
    return @_;
}

sub pis_zaka {
    my ( $zak ) = @_;
    my ($jmeno,$prumer) = $zak =~ m/(.*):(.*)/;
    printf "%-30s %0.2f\n", $jmeno, $prumer;
}

sub seznam_abecedne {
    my ( @zaci ) = @_;
    foreach my $zak ( sort @zaci ) {
        pis_zaka( $zak );
    }
}

sub seznam_prospech {
    my ( @zaci ) = @_;
    foreach my $zak ( sort srovnej_prospech @zaci ) {
        pis_zaka( $zak );
    }
}

sub srovnej_prospech {
    my ( $prvy, $druhy ) = ( $a, $b );
    $prvy =~ s/.*://;  # odstraním jména a porovnám
    $druhy =~ s/.*://;
    return ( $prvy <=> $druhy );
}
