sub generuj_filtr {
    my( $minimum, $maximum ) = @_;
    return sub {
        my @vysledek = ();
        foreach my $cislo ( @_ ) {
            if ( $cislo >= $minimum and $cislo <= $maximum ) {
                push(@vysledek, $cislo);
            }
        }
        return @vysledek;
    }
}

my $bez_znamenka = generuj_filtr(0, 255);
my $se_znamenkem = generuj_filtr(-128, 127);
my @hodnoty = ( 100, -50, 80, 320, -400, 99, 220 );
print "Jednobajtové bez znaménka:\n";
print join( "\n", $bez_znamenka->(@hodnoty) ), "\n\n";
print "Jednobajtové se znaménkem:\n";
print join( "\n", $se_znamenkem->(@hodnoty) ), "\n\n";
