# globální proměnné
my $pocetcisel = 5;           # počet losovaných čísel
my $maxcislo = 50;            # největší losované číslo
my (%tazeno, %zpracovano);    # tažená čísla, zpracované losy
my (@prvni, @druzi, @treti);  # výherci

inicializace();
vylosuj_cisla();
while ( my @los = dalsi_los() ) {
    my $poradi = urci_poradi(@los);
    if ( $poradi <= 3 ) {
        zarad_viteze($los[0], $poradi);
    }
}
vypis_viteze();

sub inicializace {
    srand;
}

sub vylosuj_cisla {
    my ( $cislo, $vylosovano ) = ( 0, 0 );
    while ( $vylosovano < $pocetcisel ) {
        $cislo = int( rand($maxcislo) ) + 1;
        if ( not $tazeno{$cislo} ) {
            $tazeno{$cislo} = 1;
            $vylosovano++;
        }
    }
    print "Tažena byla čísla: ";
    foreach $cislo ( sort {$a <=> $b} keys %tazeno ) {
        print "$cislo ";
    }
    print "\n";
}

sub dalsi_los {
    my @los = ();
    while ( my $radek = <> ) {
        chomp($radek);
        @los = kontrola_dat( split(/\s+/, $radek) );
        if ( @los ) { last; }
    }
    return @los;
}

sub kontrola_dat {
    my @los = @_;
    my $cislo = shift(@los);
    if ( cislo_uz_bylo($cislo) ) { return (); }
    @los = prover_cisla(@los);
    if ( @los ) {
        return ( $cislo, @los );
    } else {
        return ();
    }
}

sub cislo_uz_bylo {
    my ( $cislo ) = @_;
    if ( $zpracovano{$cislo} ) {
        return 1;
    } else {
        $zpracovano{$cislo} = 1;
        return 0;
    }
}

sub prover_cisla {
    my %cisla;
    foreach my $cislo ( @_ ) {
        $cisla{$cislo} = 1;
    }
    if ( (keys %cisla) > $pocetcisel ) {
        return ();
    } else {
        return sort {$a <=> $b} keys %cisla;
    }
}

sub urci_poradi {
    my $uhodl = 0;
    shift(@_);     # zbavím se čísla losu
    foreach my $cislo ( @_ ) {
        if ( $tazeno{$cislo} ) { $uhodl++; }
    }
    return $pocetcisel + 1 - $uhodl;
}

sub zarad_viteze {
    my ( $los, $poradi ) = @_;
    if ( $poradi == 1 ) { push(@prvni, $los); }
    elsif ( $poradi == 2 ) { push(@druzi, $los); }
    elsif ( $poradi == 3 ) { push(@treti, $los); }
}

sub vypis_viteze {
    print "Výherci první ceny:\n";
    vypis_seznam(@prvni);
    print "\nVýherci druhé ceny:\n";
    vypis_seznam(@druzi);
    print "\nVýherci třetí ceny:\n";
    vypis_seznam(@treti);
}

sub vypis_seznam {
    foreach my $los ( sort {$a <=> $b} @_ ) {
        print "$los\n";
    }
}
