use locale;
use lib ".";
use Zak;
use Trida;

my $trida = Trida->new();

while ( my $pokyn = dej_znak() ) {
    if ( $pokyn =~ /n/i ) { pridej_zaka(); }
    elsif ( $pokyn =~ /d/i ) { smaz_zaka(); }
    elsif ( $pokyn =~ /j/i ) { $trida->seznam_abecedne(); }
    elsif ( $pokyn =~ /p/i ) { $trida->seznam_prospech(); }
    elsif ( $pokyn =~ /r/i ) { nacti_tridu(); }
    elsif ( $pokyn =~ /s/i ) { uloz_tridu(); }
    elsif ( $pokyn =~ /q/i ) { last; }
    else { print "Neplatný příkaz!"; }
}

sub dej_znak {
    print "\nZadejte příkaz\n";
    print "  n ... přidat žáka\n";
    print "  d ... vymazat žáka\n";
    print "  j ... seznam žáků abecedně\n";
    print "  p ... seznam žáků podle prospěchu\n";
    print "  r ... načíst z disku\n";
    print "  s ... uložit na disk\n";
    print "  q ... konec\n";
    print "> ";
    my $vstup = <STDIN>;
    return substr( $vstup, 0, 1 );
}

sub pridej_zaka {
    print "Příjmení a jméno: ";
    my $jmeno = <STDIN>; chomp($jmeno);
    print "Průměr:           ";
    my $prumer = <STDIN>; chomp($prumer);
    my $zak = Zak->new(jmeno=>$jmeno, prospech=>$prumer);
    $trida->vloz_zaka($zak);
}

sub smaz_zaka {
    print "Příjmení a jméno: ";
    my $jmeno = <STDIN>; chomp($jmeno);
    if ( my $zak = $trida->hledej_zaka($jmeno) ) {
        $trida->vyrad_zaka($zak);
        print "Žák $jmeno byl vyřazen.\n";
    } else {
        print "Žák $jmeno není zařazen do třídy.\n";
    }
}

sub nacti_tridu {
    print "Jméno souboru: ";
    my $jmeno = <STDIN>; chomp($jmeno);
    $trida->nacti($jmeno);
}

sub uloz_tridu {
    print "Jméno souboru: ";
    my $jmeno = <STDIN>; chomp($jmeno);
    $trida->uloz($jmeno);
}
