use locale;
use DB_File;

tie( my %seznam, "DB_File", "telefony.db" );
while ( my $vstup = zadej_vstup() ) {
    if ( $vstup =~ s/^\+// ) {
    # přidám záznam
        my ($jmeno,$cislo) = split( /:/, $vstup );
        $seznam{$jmeno} = $cislo;
    } elsif ( $vstup =~ s/^-// ) {
    # odstraním záznam
        delete( $seznam{$vstup} )
    } elsif ( $vstup =~ s/^\*// ) {
    # hledání vzoru
        foreach my $jmeno ( sort keys %seznam ) {
            if ( $jmeno =~ /$vstup/ ) {
                pis_zaznam( $jmeno, $seznam{$jmeno} );
            }
        }
    } else {
    # hledání přesného jména
        if ( exists($seznam{$vstup}) ) {
            pis_zaznam( $vstup, $seznam{$vstup} );
        } else {
            print "Není v databázi\n";
        }
    }
}
untie( %seznam );

sub zadej_vstup {
    print "dotaz> ";
    my $vstup = <STDIN>;
    chomp($vstup);
    return $vstup;
}

sub pis_zaznam {
    my ( $jmeno, $cislo ) = @_;
    printf "%-30s %8s\n", $jmeno, $cislo;
}
