use locale;
my $jmenodat = "trida.dat";
my $jmenologu = "trida.log";
my @zaci = ();

open(PROTO, ">>$jmenologu");
while ( my $pokyn = dej_znak() ) {
    if ( $pokyn =~ /n/i ) { pridej_zaka(); }
    elsif ( $pokyn =~ /d/i ) { smaz_zaka(); }
    elsif ( $pokyn =~ /j/i ) { seznam_abecedne(); }
    elsif ( $pokyn =~ /p/i ) { seznam_prospech(); }
    elsif ( $pokyn =~ /r/i ) { nacti_tridu(); }
    elsif ( $pokyn =~ /s/i ) { uloz_tridu(); }
    elsif ( $pokyn =~ /q/i ) { last; }
    else { print "Neplatný příkaz!"; }
}
close(PROTO);

sub dej_znak {
    print "Zadejte příkaz\n";
    print "  n ... přidat žáka\n";
    print "  d ... vymazat žáka\n";
    print "  j ... seznam žáků abecedně\n";
    print "  p ... seznam žáků podle prospěchu\n";
    print "  r ... načíst z disku\n";
    print "  s ... uložit na disk\n";
    print "  q ... konec\n";
    print "> ";
    my $vstup = <STDIN>;
    return substr( $vstup, 0, 1 );
}

sub do_logu {
    print PROTO @_;
}

sub pridej_zaka {
    print "Příjmení a jméno: ";
    my $jmeno = <STDIN>; chomp($jmeno);
    print "Průměr:           ";
    my $prumer = <STDIN>; chomp($prumer);
    push( @zaci, "$jmeno:$prumer" );
    do_logu( "Přidán žák $jmeno.\n" );
}

sub smaz_zaka {
    print "Příjmení a jméno: ";
    my $jmeno = <STDIN>; chomp($jmeno);
    for ( my $i=0; $i<@zaci; $i++ ) {
        if ( $zaci[$i] =~ /^$jmeno:/ ) {
            # našel jsem - vymažu a ukončím podprogram
            splice( @zaci, $i, 1 );
            print "Žák $jmeno vymazán.\n";
            do_logu( "Vymazán žák $jmeno.\n" );
            return;
        }
    }
    print "Žák $jmeno nenalezen.\n";
}

sub pis_zaka {
    my ( $zak ) = @_;
    my ($jmeno,$prumer) = $zak =~ m/(.*):(.*)/;
    printf "%-30s %0.2f\n", $jmeno, $prumer;
}

sub seznam_abecedne {
    foreach my $zak ( sort @zaci ) {
        pis_zaka($zak);
    }
}

sub seznam_prospech {
    foreach my $zak ( sort srovnej_prospech @zaci ) {
        pis_zaka($zak);
    }
}

sub srovnej_prospech {
    my ( $prvy, $druhy ) = ( $a, $b );
    $prvy =~ s/.*://;  # odstraním jména a porovnám
    $druhy =~ s/.*://;
    return ( $prvy <=> $druhy );
}

sub nacti_tridu {
    if ( not open(TRIDA, $jmenodat) ) {
        print STDERR "Nelze načíst soubor $jmenodat !\n";
        return 0;
    }
    @zaci = ();
    while ( my $zak = <TRIDA> ) {
        chomp($zak);
        push(@zaci, $zak);
    }
    close(TRIDA);
    print "Třída načtena.\n";
    do_logu( "Načteno ze souboru.\n" );
}

sub uloz_tridu {
    if ( not open(TRIDA, ">".$jmenodat) ) {
        print STDERR "Nelze psát do souboru $jmenodat !\n";
        return 0;
    }
    foreach my $zak ( @zaci ) { print TRIDA "$zak\n"; }
    close(TRIDA);
    print "Třída uložena.\n";
    do_logu( "Uloženo do souboru.\n" );
}
